<?php

namespace patest\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KeyValueOfstringSyncDuplicationInfoWTEG5wMr StructType
 * @subpackage Structs
 */
class KeyValueOfstringSyncDuplicationInfoWTEG5wMr extends AbstractStructBase
{
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Key;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \patest\StructType\SyncDuplicationInfo
     */
    public $Value;
    /**
     * Constructor method for KeyValueOfstringSyncDuplicationInfoWTEG5wMr
     * @uses KeyValueOfstringSyncDuplicationInfoWTEG5wMr::setKey()
     * @uses KeyValueOfstringSyncDuplicationInfoWTEG5wMr::setValue()
     * @param string $key
     * @param \patest\StructType\SyncDuplicationInfo $value
     */
    public function __construct($key = null, \patest\StructType\SyncDuplicationInfo $value = null)
    {
        $this
            ->setKey($key)
            ->setValue($value);
    }
    /**
     * Get Key value
     * @return string|null
     */
    public function getKey()
    {
        return $this->Key;
    }
    /**
     * Set Key value
     * @param string $key
     * @return \patest\StructType\KeyValueOfstringSyncDuplicationInfoWTEG5wMr
     */
    public function setKey($key = null)
    {
        // validation for constraint: string
        if (!is_null($key) && !is_string($key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($key, true), gettype($key)), __LINE__);
        }
        $this->Key = $key;
        return $this;
    }
    /**
     * Get Value value
     * @return \patest\StructType\SyncDuplicationInfo|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param \patest\StructType\SyncDuplicationInfo $value
     * @return \patest\StructType\KeyValueOfstringSyncDuplicationInfoWTEG5wMr
     */
    public function setValue(\patest\StructType\SyncDuplicationInfo $value = null)
    {
        $this->Value = $value;
        return $this;
    }
}
